#!/usr/bin/perl

# Kim's MP3 Script

use utf8;
use MP3::Info;

=changelog
v1.1.2:
* Dont remember
v1.1:
* Added /bmp (Can still use /xmms)
* Changed "xmms" variables
* Displays commands availiable
v1.0:
* Autoannounce
* /mp3 to show announce in current channel
* /plays to show simpler announce (no colors) in current channel
* Still infested with "xmms" variables
* Uses /xmms instead of /bmp
=cut

my $ver = "1.1.2";
my $scriptname = "BMPxInfo v$ver";
my $author = "kim";
my $lbra = "\0034[\00314";
my $rbra = "\0034]\00315";
my $dot = "\00304*\00314";
my $front = "\00315";
$sexydot = "*";

my $auto_announce = 1;
my ($index,$title,$filename,$announce,$plays);

my $bmp_server1 = "speficic.irc.server1.com";
my $bmp_server4 = "some.other.server.org";
my $chan = "#hell";

IRC::command("/echo \0034:: $lbra$scriptname by $author Loaded$rbra \0034::");
IRC::register("$scriptname by $author", $ver, "", "");

use Net::DBus;
use Audio::FLAC::Header;
use Ogg::Vorbis::Header::PurePerl;

my ($bus,$service,$bmpx);
$bus = Net::DBus->session;
$service = $bus->get_service("org.beepmediaplayer.BMPx");
$bmpx = $service->get_object("/org/beepmediaplayer/BMPx/BmpSystemControl");

&timer;
sub timer  {
	&checkindex_handler;
	IRC::add_timeout_handler("20000", timer);
}

IRC::add_command_handler("songsend","songsend_handler");
sub songsend_handler {
	my $snick = shift;

	if ($snick) {
		IRC::command("/dcc psend $snick \"$filename\"");
	}

	return 1;
}

IRC::add_command_handler("mp3","mp3_handler");
sub mp3_handler {
	IRC::command("/say $announce");
	return 1;
}

IRC::add_command_handler("plays","plays_handler");
sub plays_handler {
	IRC::command("/me plays $plays");
	return 1;
}

IRC::add_command_handler("song", "song_handler");
sub song_handler {
		my ($stuff);
		$index = $bmpx->GetCurrentTrack() + 1;
		$ttitle = $bmpx->GetCurrentTitle();
		$filename = $bmpx->GetCurrentUri();
		
		
		$filename =~ s/file:\/\///;
		$filename =~ s/[\n\r]//;
		$filename =~ s/\%20/ /g;

		($playlist, $title) = $ttitle =~ m/\[(.*?)\] \d+\. (.*)/;
		if ($playlist =~ /.* \((.*)\)/) {
			$playlist = $1;
		}
		
		if ($filename =~ /.mp3$/i) {
			my $info = MP3::Info->new($filename);
			$length = $info->{TIME};
			$bitrate = $info->{BITRATE} . " kbps";
			$sfreq = $info->{FREQUENCY} . " kHz";
			$size = $info->{SIZE};
			$size /= (1024*1024);
			$size = sprintf("%.2f",$size);
			$announce = "\0034[\00314\#$index\0034] [\00314$title\0034] [\00314$playlist\0034] [\00314$length\0034] [\00314$sfreq\0034] [\00314$bitrate\0034] [\00314$size" . "MB\0034]\003";
			$plays = "$title ($length)";
		} elsif ($filename =~ /.ogg$/i) {
			my $ogg = Ogg::Vorbis::Header::PurePerl->new("$filename");
			my $ogginfo = $ogg->info;
			$sfreq = sprintf("%.1f kHz",$ogginfo->{rate}/1000);
			$length = sprintf("%2f",$ogginfo->{length});
			$bitrate = sprintf("%d kbps",$ogginfo->{bitrate_nominal}/1000);
			$length = oggtime($length);
			$size = getsize($filename);
			$announce = "\0034[\00314\#$index\0034] [\00314$title\0034] [\00314$playlist\0034] [\00314$length\0034] [\00314$sfreq\0034] [\00314$bitrate\0034] [\00314$size" . "MB\0034]\003";
			$plays = "$title ($length)";
		} elsif ($filename =~ /.flac$/i) {
			my $flac = Audio::FLAC::Header->new("$filename") || "Unreadable";

			if ($flac ne "Unreadable") {
				my $asdf1 = $flac->{trackLengthMinutes};
				my $asdf2 = $flac->{trackLengthSeconds};
				if ($asdf1 < 10) { $asdf1 = "0$asdf1"; }
				if ($asdf2 < 10) { $asdf2 = "0$asdf2"; }
				$length = "$asdf1:$asdf2";
				$bitrate = $flac->{bitRate};
				$bitrate = sprintf("%d kbps",$bitrate/1000);
				my $info = $flac->info();
				$sfreq = $info->{SAMPLERATE} / 1000;
				$sfreq = sprintf("%.1f kHz",$sfreq);
			} else {
				$length = "N/A";
				$bitrate = "N/A";
				$sfreq = "N/A";
			}

			$size = getsize($filename);

			$announce = "\0034[\00314\#$index\0034] [\00314$title\0034] [\00314$playlist\0034] [\00314$length\0034] [\00314$sfreq\0034] [\00314$bitrate\0034] [\00314$size" . "MB\0034]\003";
			$plays = "$title ($length)";

		} else {
			$announce = "\0034[\00314\#$index\0034] [\00314$title\0034] [\00314$playlist\0034]";
			$plays = "$title";
		}
		if ($auto_announce) {
			IRC::command_with_server("/msg $chan $announce", $bmp_server1);
			IRC::command_with_server("/msg #geek $announce", $bmp_server4);
		}

        # No further parsing necessary
        return 1;
}


sub getsize {
		my $filename = shift;
		my ($filesize,@sizeinfo);
		if ($filename !~ /http:\/\//) {
			chomp($filesize = `ls -lh "$filename"`);
		}
		$filesize =~ s/\s+/ /g;
		$size = (split(/ /,$filesize))[4];
		$size =~ s/[^\d.]//g;
		return $size;
}

sub oggtime {
        my $time = shift;
        my ($min,$sec);
        $min = int($time / 60);
        if ($min < 10) { $min = "0$min"; }
        $time %= 60;
        $sec = int($time);
        if ($sec < 10) { $sec = "0$sec"; }
        return "$min:$sec";
}

IRC::add_command_handler("checkindex", "checkindex_handler");
sub checkindex_handler {
	my $omfg;
	my $tindex = $bmpx->GetCurrentTrack();
	my $fn = $bmpx->GetCurrentUri();
	$fn =~ s/file:\/\///;
	$fn =~ s/[\n\r]//;
	$fn =~ s/\%20/ /g;
	if ($fn ne $filename && $tindex >= 0) {
		IRC::command("/song");
	}
	return 1;

} # sub end

IRC::add_command_handler("xmms","bmp_handler");
IRC::add_command_handler("bmp","bmp_handler");
sub bmp_handler {
    my $cmd = shift;
    if ($cmd eq "stop") {
		$bmpx->PlayStop();
        &msg("Stopped");
    }   
    elsif ($cmd eq "play") {
        $bmpx->PlayCurrent();
        &msg("Playing");
   }
    elsif ($cmd eq "pause") {
		$bmpx->PlayPause();
		&msg("Paused");
    }
    elsif ($cmd eq "next") {
		$bmpx->PlayNext();
        sleep(1);
        &song_handler;
    }
    elsif ($cmd eq "prev") {
		$bmpx->PlayPrev();
        sleep(1);
        &song_handler;
    }
    elsif ($cmd =~ /^vol/) {
        my ($vol) = $cmd =~ m/vol (.*)/;
        if ($vol < 0 || $vol > 100 || $vol =~ /\D/) {
            &echo("$dot Volume must be between 0 and 100");
        }
        else {
            $bmpx->VolumeSet($vol);
            &msg("Volume: $vol");
        }
    } else {
		&echo("${lbra}BMPx${rbra} Current commands: stop, play, pause, next, prev, vol");
	}

	return 1;
}

sub msg {
    my $msg = shift;
    IRC::command("/say ${lbra}BMPx${rbra} $msg");
}

sub echo {
    my $msg = shift;
    IRC::command("/echo $dot $msg");
}

