#ifndef UI_PLAYLIST_H
#define UI_PLAYLIST_H

#include <glib-object.h>


#define BMP_TYPE_WINDOW_PLAYLIST		  (bmp_window_playlist_get_type ())
#define BMP_WINDOW_PLAYLIST(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_WINDOW_PLAYLIST, BmpWindowPlaylist))
#define BMP_WINDOW_PLAYLIST_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_WINDOW_PLAYLIST, BmpWindowPlaylistClass))
#define BMP_IS_WINDOW_PLAYLIST(obj)	  (GTK_CHECK_TYPE ((obj), BMP_TYPE_WINDOW_PLAYLIST))
#define BMP_IS_WINDOW_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_WINDOW_PLAYLIST))
#define BMP_WINDOW_PLAYLIST_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_WINDOW_PLAYLIST, BmpWindowPlaylistClass))

typedef struct _BmpWindowPlaylist BmpWindowPlaylist;
typedef struct _BmpWindowPlaylistClass BmpWindowPlaylistClass;
typedef struct _BmpWindowPlaylistPrivate BmpWindowPlaylistPrivate;

struct _BmpWindowPlaylist {
	GObject parent;

        BmpWindowPlaylistPrivate *private;

	GtkWidget *window;
};

struct _BmpWindowPlaylistClass {
	GObjectClass parent;
};

GType bmp_window_playlist_get_type (void);

BmpWindowPlaylist*
bmp_window_playlist_new (void);

void
bmp_window_playlist_finalize_init (BmpWindowPlaylist *self);
 
void
bmp_window_playlist_configure(BmpWindowPlaylist *window_playlist); 

/* FIXME: Make this properties */
void
bmp_window_playlist_set_font(BmpWindowPlaylist *window_playlist, const gchar * font);

gint
bmp_window_playlist_get_vsep_width (BmpWindowPlaylist *window_main);

void
bmp_window_playlist_resize_widgets (BmpWindowPlaylist *self);

#define VSCROLLBAR_DEFAULT_WIDTH 12
#define VSEP_MIN_WIDTH 192
#define VSEP_SNAP_WIDTH 24

#define PLEDIT_INNER_XMARGIN 21
#define PLEDIT_INNER_YMARGIN 58

#define PLEDIT_ROOT_X 12
#define PLEDIT_ROOT_Y 20

#define PLEDIT_INNERPAD 2

#define PLEDIT_HEADER_TEXT_PLAYLISTS "Playlists"
#define PLEDIT_HEADER_TEXT_LIBRARY   "Library"
#define PLEDIT_HEADER_TEXT_TRACKLIST "Track List"


#endif /* UI_PLAYLIST_H */
